package dk.dionysus.hjarl;

import android.content.Context;
import android.content.SharedPreferences;

public class Controls {

	private SharedPreferences controls;
	private float ControlX[];
	private float ControlY[];
	private float ControlScale[];
	private int ControlKeyAction1[];
	private int ControlKeyAction2[];
	private int ControlKeyAction3[];
	private int ControlKeyAction4[];
	
	
	public Controls(Context context) {
		controls = context.getSharedPreferences("Controls", 0);
		ControlX = new float[10];
		ControlY = new float[10];
		ControlScale = new float[10];
		ControlKeyAction1 = new int[10];
		ControlKeyAction2 = new int[10];
		ControlKeyAction3 = new int[10];
		ControlKeyAction4 = new int[10];
		for (int x = 0; x < 10; x++) {
			//names[x] = preferences.getString("name" + x, "-");
			ControlX[x] = controls.getFloat("ControlX" + x, 0);
			ControlY[x] = controls.getFloat("ControlY" + x, 0);
			ControlScale[x] = controls.getFloat("ControlScale" + x, 1);
			ControlKeyAction1[x] = controls.getInt("ControlKeyAction1" + x, 0);
			ControlKeyAction2[x] = controls.getInt("ControlKeyAction2" + x, 0);
			ControlKeyAction3[x] = controls.getInt("ControlKeyAction3" + x, 0);
			ControlKeyAction4[x] = controls.getInt("ControlKeyAction4" + x, 0);

		}
	}

	/*
	public String getName(int x) {
		// get the name of the x-th position in the Highscore-List
		return names[x];
	}
	*/

	public float getX(int x) {
		// get the X position of the x-th control element
		//if (ControlX[x] > 0 && ControlX[x] < 100)
		return ControlX[x];
		//else return 0;
	}
	
	public float getY(int x) {
		// get the Y position of the x-th control element
		//if (ControlY[x] > 0 && ControlY[x] < 100) 
			return ControlY[x];
		//else return 0;
	}

	
	public float getScale(int x) {
		// get the Y position of the x-th control element
		//if (ControlScale[x] > 0) 
		return ControlScale[x];
		//else return 1;
	}
	
	public boolean setX(int x, float CX) {
		// set the X position of the x-th control element
		ControlX[x] = CX;
		return true;
	}
	
	public boolean setY(int x, float CY) {
		// set the Y position of the x-th control element
		ControlY[x] = CY;
		return true;
	}

	
	public boolean setScale(int x, float SY) {
		// set the scale of the x-th control element
		ControlScale[x] = SY;
		return true;
	}
	/*
	public boolean inHighscore(long score) {
		// test, if the score is in the Highscore-List
		int position;
		for (position = 0; position < 10 && this.score[position] >= score; position++)
			;
		if (position == 10)
			return false;
		return true;
	}
	*/

	public int getKey(int x, int i) {
		// set the X position of the x-th control element
		if (i == 1)	return ControlKeyAction1[x];
		if (i == 2)	return ControlKeyAction2[x];
		if (i == 3)	return ControlKeyAction3[x];
		if (i == 4)	return ControlKeyAction4[x];
		return ControlKeyAction1[x];
	}
	
	public boolean setKey(int x, int key, int i) {
		// set the X position of the x-th control element
	//SharedPreferences.Editor editor = controls.edit();
		if (i == 1)	ControlKeyAction1[x] = key;
		if (i == 2)	ControlKeyAction2[x] = key;
		if (i == 3)	ControlKeyAction3[x] = key;
		if (i == 4)	ControlKeyAction4[x] = key;
		/*
		if (i == 1)	editor.putInt("ControlKeyAction1" + x, key);
		if (i == 2)	editor.putInt("ControlKeyAction2" + x, key);
		if (i == 3)	editor.putInt("ControlKeyAction3" + x, key);
		if (i == 4)	editor.putInt("ControlKeyAction4" + x, key);
		

		
	editor.commit();*/
		
		return true;
	}
	
	
	public boolean changeControl(int control, float X, float Y, float S) {
		// Change the control settings
		this.ControlX[control] = X;
		this.ControlY[control] = Y;
		this.ControlScale[control] = S;
		
		
		
		SharedPreferences.Editor editor = controls.edit();
			editor.putFloat("ControlX" + control, this.ControlX[control]);
			editor.putFloat("ControlY" + control, this.ControlY[control]);
			editor.putFloat("ControlScale" + control, this.ControlScale[control]);
			editor.putInt("ControlKeyAction1" + control, this.ControlKeyAction1[control]);
			editor.putInt("ControlKeyAction2" + control, this.ControlKeyAction2[control]);
			editor.putInt("ControlKeyAction3" + control, this.ControlKeyAction3[control]);
			editor.putInt("ControlKeyAction4" + control, this.ControlKeyAction4[control]);
		editor.commit();
		return true;

	}
	
	/*
	public boolean addScore(String name, long score) {
		// add the score with the name to the Highscore-List
		int position;
		for (position = 0; position < 10 && this.score[position] > score; position++);
		
		if (position == 10)
			return false;
		for (int x = 9; x > position; x--) {
			names[x] = names[x - 1];
			this.score[x] = this.score[x - 1];
		}
		
		this.names[position] = new String(name);
		this.score[position] = score;
		SharedPreferences.Editor editor = preferences.edit();
		for (int x = 0; x < 10; x++) {
			editor.putString("name" + x, this.names[x]);
			editor.putLong("score" + x, this.score[x]);
		}
		editor.commit();
		return true;
	}
	*/
}